#!/usr/bin/python3

import sys
import random

default = {
    "n": 10,
    "m": 10,
    "vertical": 1,
}

def cmdlinearg(name):
    for arg in sys.argv:
        if arg.startswith(name + "="):
            return arg.split("=")[1]
    return default[name]

def main():
    random.seed(int(sys.argv[-1]))
    n = int(cmdlinearg("n"))
    m = int(cmdlinearg("m"))
    vertical = int(cmdlinearg("vertical"))

    print(n,m)
    for i in range(0, n):
        line = []
        for j in range(0, m):
            if (i%2 == 0 and vertical == 0) or (j%2 == 0 and vertical == 1):
                line.append('2')
            else:
                line.append('1')
        print("".join(line))



if __name__ == "__main__":
    main()