import networkx as nx
from networkx.drawing.nx_pydot import graphviz_layout
import matplotlib.pyplot as plt
import sys
G=nx.DiGraph()

[n, w] = [int(x) for x in input().split()]

nodes = {0: 'Warcamp: {}'.format}
#G.add_node(0)
for i in range(1, n+1):
    parent, capacity, fill = map(int, input().split())
    nodes[i] = "{}: {}/{}".format(i, fill, capacity)
#    G.add_node(i)
    G.add_edge(i, parent)


print("Nodes of graph: ")
print(G.nodes())
print("Edges of graph: ")
print(G.edges())
pos = graphviz_layout(G, prog="dot")
nx.draw(G, pos, node_size=3000, labels=nodes)
plt.savefig(sys.argv[1])